// Code generated by mockery v2.10.2. DO NOT EDIT.

package mocks

import (
	models "bots-ms/models"

	mock "github.com/stretchr/testify/mock"

	ms_sharedmodels "gitlab.com/nikita.morozov/ms-shared/models"
)

// BotUserUsecase is an autogenerated mock type for the BotUserUsecase type
type BotUserUsecase struct {
	mock.Mock
}

// Count provides a mock function with given fields:
func (_m *BotUserUsecase) Count() (uint64, error) {
	ret := _m.Called()

	var r0 uint64
	if rf, ok := ret.Get(0).(func() uint64); ok {
		r0 = rf()
	} else {
		r0 = ret.Get(0).(uint64)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Create provides a mock function with given fields: item
func (_m *BotUserUsecase) Create(item *models.BotUser) error {
	ret := _m.Called(item)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.BotUser) error); ok {
		r0 = rf(item)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Delete provides a mock function with given fields: id
func (_m *BotUserUsecase) Delete(id uint) error {
	ret := _m.Called(id)

	var r0 error
	if rf, ok := ret.Get(0).(func(uint) error); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Get provides a mock function with given fields: id
func (_m *BotUserUsecase) Get(id uint) (*models.BotUser, error) {
	ret := _m.Called(id)

	var r0 *models.BotUser
	if rf, ok := ret.Get(0).(func(uint) *models.BotUser); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.BotUser)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetByMeta provides a mock function with given fields: botID, meta
func (_m *BotUserUsecase) GetByMeta(botID uint, meta string) (*models.BotUser, error) {
	ret := _m.Called(botID, meta)

	var r0 *models.BotUser
	if rf, ok := ret.Get(0).(func(uint, string) *models.BotUser); ok {
		r0 = rf(botID, meta)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.BotUser)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint, string) error); ok {
		r1 = rf(botID, meta)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetByUserId provides a mock function with given fields: botID, userId
func (_m *BotUserUsecase) GetByUserId(botID uint, userId string) (*models.BotUser, error) {
	ret := _m.Called(botID, userId)

	var r0 *models.BotUser
	if rf, ok := ret.Get(0).(func(uint, string) *models.BotUser); ok {
		r0 = rf(botID, userId)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.BotUser)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint, string) error); ok {
		r1 = rf(botID, userId)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// List provides a mock function with given fields: handler, opts
func (_m *BotUserUsecase) List(handler string, opts *ms_sharedmodels.ListOptions) (*[]models.BotUser, ms_sharedmodels.Paginator, error) {
	ret := _m.Called(handler, opts)

	var r0 *[]models.BotUser
	if rf, ok := ret.Get(0).(func(string, *ms_sharedmodels.ListOptions) *[]models.BotUser); ok {
		r0 = rf(handler, opts)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*[]models.BotUser)
		}
	}

	var r1 ms_sharedmodels.Paginator
	if rf, ok := ret.Get(1).(func(string, *ms_sharedmodels.ListOptions) ms_sharedmodels.Paginator); ok {
		r1 = rf(handler, opts)
	} else {
		r1 = ret.Get(1).(ms_sharedmodels.Paginator)
	}

	var r2 error
	if rf, ok := ret.Get(2).(func(string, *ms_sharedmodels.ListOptions) error); ok {
		r2 = rf(handler, opts)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// Update provides a mock function with given fields: item
func (_m *BotUserUsecase) Update(item *models.BotUser) error {
	ret := _m.Called(item)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.BotUser) error); ok {
		r0 = rf(item)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}
